import heapq

# Чтение входных данных
n, k = map(int, input().split())

# Инициализация кучи
heap = list(range(1, n + 1))
heapq.heapify(heap)

# Обработка запросов
for _ in range(k):
    query = input().split()
    if query[0] == '+':
        # Добавление нового пассажира
        free_seat = heapq.heappop(heap)  # Извлекаем минимальный элемент из кучи
        print(free_seat)
    else:
        # Уход пассажира
        seat_number = int(query[1])  # Номер места, которое освободился
        heapq.heappush(heap, seat_number)  # Добавляем освободившееся место в кучу
